/*--------------------------------------------------------------------------*/
/*--------------------------- File DCR.h -----------------------------------*/
/*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/*----------------------------- DEFINITIONS --------------------------------*/
/*--------------------------------------------------------------------------*/

#ifndef DCR_H
#define DCR_H

/*--------------------------------------------------------------------------*/
/*------------------------------ INCLUDES ----------------------------------*/
/*--------------------------------------------------------------------------*/

using namespace std;	

/*--------------------------------------------------------------------------*/
/*--------------------------- CLASS DCR ------------------------------------*/
/*--------------------------------------------------------------------------*/

class DCR 
{

/*--------------------------------------------------------------------------*/
/*----------------------- PUBLIC PART OF THE CLASS -------------------------*/
/*--------------------------------------------------------------------------*/

 public:

/*--------------------------------------------------------------------------*/
/*---------------------------- PUBLIC TYPES --------------------------------*/
/*--------------------------------------------------------------------------*/

  enum DCRStatus { 
    OK = 0, 		
    Stopped,     
    Infeasible,  
    Unbounded,   
    Error        
    };
	
  struct DCRFlow {
    int sourcenode;     
    int sinknode;       
    double burst;      
    double rate;       
    double deadline;   
    double *costs; 
    double *caps; 
    };

  struct DCRLink {
    int startnode;
    int endnode;
    double speed;     
    double mutualcap;  
    double delay;     
    };

  struct DCRNode {
    double delay; 
    };
			
 };

#endif
	
/*--------------------------------------------------------------------------*/
/*-------------------------- End File DCR.h --------------------------------*/
/*--------------------------------------------------------------------------*/
	
